<?php

/*
Copyright (C) 2001-2007
by Justin Woods <justin@woodsmedia.com>
and David Sowder <david@sowder.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

// $Id: index.php 466 2007-03-25 23:56:19Z davids $

// Check the PHP version before doing anything else
// The check seems to have to be here because webstamp.inc doesn't parse
// under the PHP 3.x that I've tried it with
if( floor( phpversion()) < 4 ) {
  echo "<html>\n";
  echo " <head>\n";
  echo "  <title>Webstamp error</title>\n";
  echo " </head>\n";
  echo " <body bgcolor=\"#ffffff\">\n";
  echo "  <center><font size=+3 color=\"#ff0000\">Webstamp error</font></center><br>\n";
  echo "  The Webstamp framework currently requires PHP version 4.x<br><br>\n";
  echo "  You shouldn't see this message unless you're a Webstamp website developer.<br><br>\n";
  if( !isset( $_SERVER[ 'SERVER_ADMIN' ] ) && isset( $SERVER_ADMIN )) {
    $_SERVER[ 'SERVER_ADMIN' ] = $SERVER_ADMIN;
  }
  echo "  Please notify the server administrator: {$_SERVER[ 'SERVER_ADMIN' ]}\n";
  echo " </body>\n";
  echo "</html>\n";
  die();
}

function bomb_on_silly_error() {
  global $FIRSTREAL, $SECONDREAL;

  // **FIXME**
  echo "<html>\n";
  echo " <head>\n";
  echo "  <title>Oops</title>\n";
  echo " </head>\n";
  echo " <body bgcolor=\"#ffffff\">\n";
  echo "  We made a silly error somewhere and now our site is broken.<br>\n";
  echo "  Perhaps you can at least get somewhere useful from the\n";
  echo "  \"<a href=\"/\">Front Door</a>\"<br>\n";
  echo "  <br>\n";
  echo "  <p>\n";
  echo "   <i>\n";
  echo "    url: {$_SERVER[ 'REQUEST_URI' ]}<br>\n";
  echo "    SCRIPT_FILENAME: {$_SERVER[ 'SCRIPT_FILENAME' ]}<br>\n";
  echo "    FIRSTREAL: $FIRSTREAL<br>\n";
  echo "    SECONDREAL: $SECONDREAL<br>\n";
  echo "   </i>\n";
  echo "  </p>\n";
  echo " </body>\n";
  echo "</html>\n";
  die( '' );
}
  
// Required variable "setup" is below
// Check for existence of _SERVER[ 'SCRIPT_FILENAME' ]
if( !isset( $_SERVER[ 'SCRIPT_FILENAME' ] )) {
  if( isset( $SCRIPT_FILENAME )) {
    $_SERVER[ 'SCRIPT_FILENAME' ] = $SCRIPT_FILENAME;
  } else {
    echo "<html>\n";
    echo " <head>\n";
    echo "  <title>Oops</title>\n";
    echo " </head>\n";
    echo " <body bgcolor=\"#ffffff\">\n";
    echo "  Sorry, our website is broken.  We are working to have it repaired shortly.<br>\n";
    echo "  <br>\n";
    echo "  <code>_SERVER[ 'SCRIPT_FILENAME' ] is undefined</code>\n";
    echo " </body>\n";
    echo "</html>\n";
    die( '' );
  }
}
// Check for existence of _SERVER[ 'REQUEST_URI' ] or _SERVER[ 'SCRIPT_URL' ]
if( !isset( $_SERVER[ 'REQUEST_URI' ] ) and !isset( $_SERVER[ 'SCRIPT_URL' ] )) {
  if( isset( $REQUEST_URI )) {
    $_SERVER[ 'REQUEST_URI' ] = $REQUEST_URI;
  } else if( isset( $SCRIPT_URL )) {
    $_SERVER[ 'REQUEST_URI' ] = $SCRIPT_URL;
  } else {
    echo "<html>\n";
    echo " <head>\n";
    echo "  <title>Oops</title>\n";
    echo " </head>\n";
    echo " <body bgcolor=\"#ffffff\">\n";
    echo "  Sorry, our website is broken.  We are working to have it repaired shortly.<br>\n";
    echo "  <br>\n";
    echo "  <code>_SERVER[ 'REQUEST_URI' ] and _SERVER[ 'SCRIPT_URL' ] are both undefined</code>\n";
    echo " </body>\n";
    echo "</html>\n";
    die( '' );
  }
}
// Fixup if we have _SERVER[ 'SCRIPT_URL' ] but not _SERVER[ 'REQUEST_URI' ]
if( !isset( $_SERVER[ 'REQUEST_URI' ] ) and isset( $_SERVER[ 'SCRIPT_URL' ] )) {
  $_SERVER[ 'REQUEST_URI' ] = $_SERVER[ 'SCRIPT_URL' ];
}
$THISDIR = dirname( $_SERVER[ 'SCRIPT_FILENAME' ] ) . '/';
$THISDIR = str_replace( '//', '/', $THISDIR );
$FIRSTREL = readlink( $_SERVER[ 'SCRIPT_FILENAME' ] );
// readlink() doesn't preserve directory relativeness from the
// input, so we have to jump through hoops.  It's correct behavior,
// but it seems it'd be more useful if it preserved the relativeness
// of the input symlink.  I guess most people don't use nested
// symlinks much or something.
$FIRSTREAL = $THISDIR;
while( substr( $FIRSTREL, 0, 3 ) == '../' ) {
  if( $FIRSTREAL == '' ) {
    bomb_on_silly_error();  // Never returns
  }
  $FIRSTREL = substr( $FIRSTREL, 3 );
  $FIRSTREAL = dirname( $FIRSTREAL ) . '/';
}
$FIRSTREAL = str_replace( '//', '/', $FIRSTREAL . '/' . $FIRSTREL );
if( is_link( $FIRSTREAL )) {
  $SECONDFOLLOW = readlink( $FIRSTREAL );
  $SECONDREL = $SECONDFOLLOW;
  $SECONDREAL = dirname( $FIRSTREAL ) . '/';
  while( substr( $SECONDREL, 0, 3 ) == '../' ) {
    if( $SECONDREAL == '' ) {
      bomb_on_silly_error();  // Never returns
    }
    $SECONDREL = substr( $SECONDREL, 3 );
    $SECONDREAL = dirname( $SECONDREAL ) . '/';
  }
  $SECONDREAL = $SECONDREAL . $SECONDREL;
  if( is_link( $SECONDREAL )) {
    bomb_on_silly_error();  // Never returns
  }
  $RELOURDIR = dirname( './' . dirname( readlink( $_SERVER[ 'SCRIPT_FILENAME' ] )));
  if( substr( $RELOURDIR, 0, 2 ) == './' ) {
    $RELOURDIR = substr( $RELOURDIR, 2 );
  }
  $RELROOTDIR = $RELOURDIR . '/' . dirname( dirname( dirname( readlink( readlink( $_SERVER[ 'SCRIPT_FILENAME' ] )))));
} else {
  $RELOURDIR = dirname( './' . dirname( readlink( $_SERVER[ 'SCRIPT_FILENAME' ] )));
  if( substr( $RELOURDIR, 0, 2 ) == './' ) {
    $RELOURDIR = substr( $RELOURDIR, 2 );
  }
  $RELROOTDIR = $RELOURDIR;
}

$OURDIR = str_replace( '//', '/', realpath( $THISDIR . '/' . $RELOURDIR ) . '/' );
$ROOTDIR = str_replace( '//', '/', realpath( $THISDIR . '/' .  $RELROOTDIR ) . '/' );
$OURLIBS = $OURDIR . '.libs/';
$ROOTLIBS = $ROOTDIR . '.libs/';
$OURCACHE = $OURDIR . '.cache/';
$ROOTCACHE = $ROOTDIR . '.cache/';
$OURDATA = $OURDIR . '.data/';
$ROOTDATA = $ROOTDIR . '.data/';
$OURGFX = $OURDIR . '.gfx/';
$ROOTGFX = $ROOTDIR . '.gfx/';

/*
echo "<br>\n";
echo "DEBUG: THISDIR: &lt;${THISDIR}&gt;<br>\n";
echo "DEBUG: RELOURDIR: &lt;${RELOURDIR}&gt;<br>\n";
echo "DEBUG: OURDIR: &lt;${OURDIR}&gt;<br>\n";
echo "DEBUG: OURCACHE: &lt;${OURCACHE}&gt;<br>\n";
echo "DEBUG: OURDATA: &lt;${OURDATA}&gt;<br>\n";
echo "DEBUG: OURGFX: &lt;${OURGFX}&gt;<br>\n";
echo "DEBUG: OURLIBS: &lt;${OURLIBS}&gt;<br>\n";
echo "DEBUG: RELROOTDIR: &lt;${RELROOTDIR}&gt;<br>\n";
echo "DEBUG: ROOTDIR: &lt;${ROOTDIR}&gt;<br>\n";
echo "DEBUG: ROOTCACHE: &lt;${ROOTCACHE}&gt;<br>\n";
echo "DEBUG: ROOTDATA: &lt;${ROOTDATA}&gt;<br>\n";
echo "DEBUG: ROOTGFX: &lt;${ROOTGFX}&gt;<br>\n";
echo "DEBUG: ROOTLIBS: &lt;${ROOTLIBS}&gt;<br>\n";
die( '' );
*/

require_once( $ROOTLIBS . 'webstamp.inc' );  // get_reldir_matched_url() needed next
$pos = strrpos( $_SERVER[ 'REQUEST_URI' ], '?' );
if( $pos > 0 ) {
  $CLEANER_URI = substr( $_SERVER[ 'REQUEST_URI' ], 0, $pos );
}
else {
  $CLEANER_URI = $_SERVER[ 'REQUEST_URI' ];
}
$pos = strrpos( $CLEANER_URI, '/' );
if( $pos > 0 ) {
  $CLEANED_URI = substr( $CLEANER_URI, 0, $pos + 1 );
}
else {
  $CLEANED_URI = $CLEANER_URI;
}
$OURURL = get_reldir_matched_url( $RELOURDIR, $CLEANED_URI );
$ROOTURL = get_reldir_matched_url( $RELROOTDIR, $CLEANED_URI );
$OURGFXURL = $OURURL . '.gfx/';
$ROOTGFXURL = $ROOTURL . '.gfx/';
$THISURL = $CLEANED_URI;

/*
echo "<br>\n";
echo "DEBUG: THISDIR: &lt;${THISDIR}&gt;<br>\n";
echo "DEBUG: THISURL: &lt;${THISURL}&gt;<br>\n";
echo "DEBUG: RELOURDIR: &lt;${RELOURDIR}&gt;<br>\n";
echo "DEBUG: OURDIR: &lt;${OURDIR}&gt;<br>\n";
echo "DEBUG: OURCACHE: &lt;${OURCACHE}&gt;<br>\n";
echo "DEBUG: OURDATA: &lt;${OURDATA}&gt;<br>\n";
echo "DEBUG: OURGFX: &lt;${OURGFX}&gt;<br>\n";
echo "DEBUG: OURLIBS: &lt;${OURLIBS}&gt;<br>\n";
echo "DEBUG: OURURL: &lt;${OURURL}&gt;<br>\n";
echo "DEBUG: OURGFXURL: &lt;${OURGFXURL}&gt;<br>\n";
echo "DEBUG: RELROOTDIR: &lt;${RELROOTDIR}&gt;<br>\n";
echo "DEBUG: ROOTDIR: &lt;${ROOTDIR}&gt;<br>\n";
echo "DEBUG: ROOTCACHE: &lt;${ROOTCACHE}&gt;<br>\n";
echo "DEBUG: ROOTDATA: &lt;${ROOTDATA}&gt;<br>\n";
echo "DEBUG: ROOTGFX: &lt;${ROOTGFX}&gt;<br>\n";
echo "DEBUG: ROOTLIBS: &lt;${ROOTLIBS}&gt;<br>\n";
echo "DEBUG: ROOTURL: &lt;${ROOTURL}&gt;<br>\n";
echo "DEBUG: ROOTGFXURL: &lt;${ROOTGFXURL}&gt;<br>\n";
die( '' );
*/

require_once( "${ROOTLIBS}siteconfig.inc" );

//
// Required variable "setup" is above
// Page begins here
// *************************************

$dir_list = get_directory_steps_to_libs_dir( $_SERVER[ 'SCRIPT_FILENAME' ] );

$workingset = implode( '', file( "${OURLIBS}/^MAIN" ));

while( list( $k, $dir ) = each( $dir_list )) {
  $workingset = process( $OURLIBS, $dir, $workingset, '^' );
}
$workingset = process( $OURLIBS, dirname( $_SERVER[ 'SCRIPT_FILENAME' ] ), $workingset );

if( !isset( $_GET[ 'unknowns' ] )) {
  if( isset( $unknowns )) {
    $_GET[ 'unknowns' ] = $unknowns;
  } else {
    $_GET[ 'unknowns' ] = "remove";
  }
}
switch( $_GET[ 'unknowns' ] ) {
  case "keep":
    break;
  case "remove":
    // $workingset = preg_replace("/\{[^}]+\}/", '', $workingset);
    $workingset = ereg_replace("\{=?_?[A-Z][A-Za-z0-9_]*\}", '', $workingset);
    break;
  case "comment":
    // $workingset = preg_replace("/\{([^}]+)\}/", "<!-- Template $varname: Variable \\1 undefined -->", $workingset);
    $workingset = ereg_replace( "\{(=?_?[A-Z][A-Za-z0-9_]*)\}", "<!-- Template Variable '\\1' undefined -->", $workingset);
    break;
}
if( !isset( $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] ) && isset( $HTTP_ACCEPT_ENCODING )) {
  $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] = $HTTP_ACCEPT_ENCODING;
}
if( $USE_COMPRESSION && isset( $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] ) && $encoding = gzip_accepted( $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] )) {
  $gzdata = '\x1f\x8b\x08\x00\x00\x00\x00\x00'; // gzip header
  $size = strlen( $workingset );
  $crc = crc32( $workingset );
  $gzdata .= gzcompress( $workingset, 9 );
  $gzdata = substr( $gzdata, 0, strlen( $gzdata ) - 4 ); // fix crc bug
  $gzdata .= pack( 'V',$crc ) . pack( 'V', $size );
  header( 'Content-Encoding: ' . $encoding );
  header( 'Content-Length: ' . strlen( $gzdata ));
  echo $gzdata;
} else {
  echo $workingset;
}

?>
